* admin/gitmerge.el (gitmerge-missing):
[emacs.git] / Makefile.in
blob3f46d0acafaa0472b688c98f5d56762a43bbb0df
1 ### @configure_input@
3 # Copyright (C) 1992-2017 Free Software Foundation, Inc.
5 # This file is part of GNU Emacs.
7 # GNU Emacs is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
12 # GNU Emacs is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with GNU Emacs. If not, see <https://www.gnu.org/licenses/>.
20 ### Commentary:
22 # make all to compile and build Emacs.
23 # make install to install it.
24 # make TAGS to update tags tables.
26 # make clean or make mostlyclean
27 # Delete all files from the current directory that are normally
28 # created by building the program. Don't delete the files that
29 # record the configuration. Also preserve files that could be made
30 # by building, but normally aren't because the distribution comes
31 # with them.
33 # Delete '.dvi' files here if they are not part of the distribution.
35 # make distclean
36 # Delete all files from the current directory that are created by
37 # configuring or building the program. If you have unpacked the
38 # source and built the program without creating any other files,
39 # 'make distclean' should leave only the files that were in the
40 # distribution.
42 # make maintainer-clean
43 # Delete everything from the current directory that can be
44 # reconstructed with this Makefile. This typically includes
45 # everything deleted by distclean, plus more: .elc files,
46 # C source files produced by Bison, tags tables, info files,
47 # and so on.
49 # make extraclean
50 # Still more severe - delete backup and autosave files, too.
51 # Also generated files that do not normally change and can be slow
52 # to rebuild (eg leim/ja-dic).
54 # make bootstrap
55 # Removes all the compiled files to force a new bootstrap from a
56 # clean slate, and then build in the normal way.
58 # make docs
59 # Make Emacs documentation files from their sources; requires makeinfo.
61 # make check or make check-expensive
62 # Run Emacs test suite. check-expensive runs also tests which
63 # take more time to perform.
65 SHELL = @SHELL@
67 # This only matters when inheriting a CDPATH not starting with the
68 # current directory.
69 CDPATH=
71 # ==================== Things 'configure' Might Edit ====================
73 cache_file = @cache_file@
74 CONFIGURE_FLAGS = --cache-file=$(cache_file)
76 AWK = @AWK@
78 EXEEXT=@EXEEXT@
80 ### These help us choose version- and architecture-specific directories
81 ### to install files in.
83 ### This should be the number of the Emacs version we're building,
84 ### like '24.5' or '25.0.50'.
85 version=@version@
87 ### This should be the name of the configuration we're building Emacs
88 ### for, like 'x86_64-unknown-linux-gnu' or 'powerpc-ibm-aix7.1.2.0'.
89 configuration=@configuration@
91 ### The nt/ subdirectory gets built only for MinGW
92 NTDIR=@NTDIR@
94 # 'make' verbosity.
95 AM_DEFAULT_VERBOSITY = @AM_DEFAULT_VERBOSITY@
97 AM_V_GEN = $(am__v_GEN_@AM_V@)
98 am__v_GEN_ = $(am__v_GEN_@AM_DEFAULT_V@)
99 am__v_GEN_0 = @echo " GEN " $@;
100 am__v_GEN_1 =
102 AM_V_at = $(am__v_at_@AM_V@)
103 am__v_at_ = $(am__v_at_@AM_DEFAULT_V@)
104 am__v_at_0 = @
105 am__v_at_1 =
107 # ==================== Where To Install Things ====================
109 # Location to install Emacs.app under GNUstep / macOS.
110 # Later values may use these.
111 ns_appbindir=@ns_appbindir@
112 ns_appresdir=@ns_appresdir@
113 # Either yes or no depending on whether this is a relocatable Emacs.app.
114 ns_self_contained=@ns_self_contained@
116 # The default location for installation. Everything is placed in
117 # subdirectories of this directory. The default values for many of
118 # the variables below are expressed in terms of this one, so you may
119 # not need to change them. This defaults to /usr/local.
120 prefix=@prefix@
122 # Like 'prefix', but used for architecture-specific files.
123 exec_prefix=@exec_prefix@
125 # Where to install Emacs and other binaries that people will want to
126 # run directly (like etags).
127 bindir=@bindir@
129 # The root of the directory tree for read-only architecture-independent
130 # data files. ${datadir}, ${infodir} and ${mandir} are based on this.
131 datarootdir=@datarootdir@
133 # Where to install architecture-independent data files. ${lispdir}
134 # and ${etcdir} are subdirectories of this.
135 datadir=@datadir@
137 # Where to install and expect the files that Emacs modifies as it
138 # runs. These files are all architecture-independent.
139 # Right now, this is not used.
140 sharedstatedir=@sharedstatedir@
142 # Where to install and expect executable files to be run by Emacs
143 # rather than directly by users (and other architecture-dependent
144 # data, although Emacs does not have any). The executables
145 # are actually installed in ${archlibdir}, which is (normally)
146 # a subdirectory of this.
147 libexecdir=@libexecdir@
149 # Currently only used for the systemd service file.
150 libdir=@libdir@
152 # Where to install Emacs's man pages.
153 # Note they contain cross-references that expect them to be in section 1.
154 mandir=@mandir@
155 man1dir=$(mandir)/man1
157 # Where to install and expect the info files describing Emacs.
158 infodir=@infodir@
159 # Info files not in the doc/misc directory (we get those via make echo-info).
160 INFO_NONMISC=emacs.info eintr.info elisp.info
162 # If no makeinfo was found and configured --without-makeinfo, "no"; else "yes".
163 HAVE_MAKEINFO=@HAVE_MAKEINFO@
165 # Directory for local state files for all programs.
166 localstatedir=@localstatedir@
168 # Where to look for bitmap files.
169 bitmapdir=@bitmapdir@
171 # Where to find the source code. The source code for Emacs's C kernel is
172 # expected to be in ${srcdir}/src, and the source code for Emacs's
173 # utility programs is expected to be in ${srcdir}/lib-src. This is
174 # set by the configure script's '--srcdir' option.
176 # We use $(srcdir) explicitly in dependencies so as not to depend on VPATH.
177 srcdir=@srcdir@
178 abs_srcdir=@abs_srcdir@
180 # Where the manpage source files are kept.
181 mansrcdir=$(srcdir)/doc/man
183 # Tell make where to find source files; this is needed for the makefiles.
184 VPATH=@srcdir@
186 # Where to find the application default.
187 x_default_search_path=@x_default_search_path@
189 # Where the etc/emacs.desktop file is to be installed.
190 desktopdir=$(datarootdir)/applications
192 # Where the etc/emacs.appdata.xml file is to be installed.
193 appdatadir=$(datarootdir)/appdata
195 # Where the etc/emacs.service file is to be installed.
196 # The system value (typically /usr/lib/systemd/user) can be
197 # obtained with: pkg-config --variable=systemduserunitdir systemd
198 # but that does not respect configure's prefix.
199 # It is not clear where we should install this file when
200 # prefix != /usr (or /usr/local?) (eg for non-root installs).
201 # Other options include ~/.config/systemd/user/,
202 # $XDG_RUNTIME_DIR/systemd/user/
203 # It seems the user may end up having to make a manual link...
204 systemdunitdir=$(libdir)/systemd/user
206 # Where the etc/images/icons/hicolor directory is to be installed.
207 icondir=$(datarootdir)/icons
209 # The source directory for the icon files.
210 iconsrcdir=$(srcdir)/etc/images/icons
212 # ==================== Emacs-specific directories ====================
214 # These variables hold the values Emacs will actually use. They are
215 # based on the values of the standard Make variables above.
217 # Where to install the lisp files distributed with Emacs.
218 # This includes the Emacs version, so that the lisp files for different
219 # versions of Emacs will install themselves in separate directories.
220 lispdir=@lispdir@
222 # Directories Emacs should search for standard lisp files.
223 # The default is ${lispdir}.
224 standardlisppath=@standardlisppath@
226 # Directories Emacs should search for lisp files specific to this
227 # site (i.e. customizations), before consulting ${standardlisppath}.
228 # This should be a colon-separated list of directories.
229 locallisppath=@locallisppath@
231 # Where Emacs will search to find its lisp files. Before
232 # changing this, check to see if your purpose wouldn't
233 # better be served by changing locallisppath. This
234 # should be a colon-separated list of directories.
235 # The default is ${locallisppath}:${standardlisppath}.
236 lisppath=@lisppath@
238 # Where Emacs will search for its lisp files while building.
239 # This is only used during the process of compiling Emacs,
240 # to help Emacs find its lisp files before they've been installed
241 # in their final location.
242 # This should be a colon-separated list of directories.
243 # Normally it points to the lisp/ directory in the sources.
244 # NB lread.c relies on lisp/ being first here.
245 buildlisppath=${abs_srcdir}/lisp
247 # Where to install the other architecture-independent
248 # data files distributed with Emacs (like the tutorial,
249 # the cookie recipes and the Zippy database). This path
250 # usually contains the Emacs version number, so the data
251 # files for multiple versions of Emacs may be installed
252 # at once.
253 etcdir=@etcdir@
255 # Where to put executables to be run by Emacs rather than
256 # the user. This path usually includes the Emacs version
257 # and configuration name, so that multiple configurations
258 # for multiple versions of Emacs may be installed at
259 # once.
260 archlibdir=@archlibdir@
262 # Where to put the etc/DOC file.
263 etcdocdir=@etcdocdir@
265 # User or group of the auxiliary program update-game-score, which is
266 # installed on platforms with a game directory shared by multiple users.
267 # On other platforms Emacs can update the score files itself.
268 gameuser=@gameuser@
269 gamegroup=@gamegroup@
270 # Where to install game score files, if gameuser or gamegroup is nonempty.
271 gamedir=@gamedir@
272 # Nonempty if and only if a shared gamedir is used.
273 use_gamedir=$(gameuser)$(gamegroup)
275 # ==================== Utility Programs for the Build ====================
277 # Allow the user to specify the install program.
278 # Note that if the system does not provide a suitable install,
279 # configure will use build-aux/install-sh. Annoyingly, it does
280 # not use an absolute path. So we must take care to always run
281 # INSTALL-type commands from the directory containing the Makefile.
282 # This explains (I think) the cd thisdir seen in several install rules.
283 INSTALL = @INSTALL@
284 INSTALL_PROGRAM = @INSTALL_PROGRAM@
285 INSTALL_DATA = @INSTALL_DATA@
286 INSTALL_INFO = @INSTALL_INFO@
287 # By default, we uphold the dignity of our programs.
288 INSTALL_STRIP =
289 MKDIR_P = @MKDIR_P@
290 # Create a link to a file in the same directory as the target.
291 LN_S_FILEONLY = @LN_S_FILEONLY@
293 # We use gzip to compress installed .el and some .txt files.
294 GZIP_PROG = @GZIP_PROG@
296 # ============================= Targets ==============================
298 # Program name transformation.
299 TRANSFORM = @program_transform_name@
301 # What emacs should be called when installed.
302 EMACS_NAME = `echo emacs | sed '$(TRANSFORM)'`
303 EMACS = ${EMACS_NAME}${EXEEXT}
304 EMACSFULL = `echo emacs-${version} | sed '$(TRANSFORM)'`${EXEEXT}
306 # Subdirectories to make recursively.
307 SUBDIR = $(NTDIR) lib lib-src src lisp
309 # The subdir makefiles created by config.status.
310 SUBDIR_MAKEFILES_IN = @SUBDIR_MAKEFILES_IN@
311 SUBDIR_MAKEFILES = $(patsubst ${srcdir}/%,%,${SUBDIR_MAKEFILES_IN:.in=})
313 # Non-makefile files created by config.status.
314 CONFIG_STATUS_FILES_IN = \
315 ${srcdir}/nt/emacs.rc.in ${srcdir}/nt/emacsclient.rc.in \
316 ${srcdir}/doc/man/emacs.1.in
318 # Subdirectories to install, and where they'll go. lib-src's and nt's
319 # makefiles know how to install them, so we don't do that here.
320 # Directories that cannot simply be copied, eg info, are treated
321 # separately.
322 COPYDIR = ${srcdir}/etc ${srcdir}/lisp
323 COPYDESTS = "$(DESTDIR)${etcdir}" "$(DESTDIR)${lispdir}"
325 all: ${SUBDIR} info
327 .PHONY: all ${SUBDIR} blessmail epaths-force epaths-force-w32 etc-emacsver
329 # If configure were to just generate emacsver.tex from emacsver.tex.in
330 # in the normal way, the timestamp of emacsver.tex would always be
331 # newer than that of the pdf files, which are prebuilt in release tarfiles.
332 # So we use this rule, and move-if-change, to avoid that.
333 etc-emacsver:
334 majorversion=`echo ${version} | sed 's/\..*//'`; \
335 sed "s/[@]majorversion@/$${majorversion}/" \
336 ${srcdir}/etc/refcards/emacsver.tex.in > emacsver.tex.$$$$ && \
337 ${srcdir}/build-aux/move-if-change emacsver.tex.$$$$ \
338 ${srcdir}/etc/refcards/emacsver.tex
340 # The shared gamedir name as a C string literal, or a null ptr if not in use.
341 PATH_GAME = $(if $(use_gamedir),"$(gamedir)",((char const *) 0))
343 # Generate epaths.h from epaths.in. This target is invoked by 'configure'.
344 # See comments in configure.ac for why it is done this way, as opposed
345 # to just letting configure generate epaths.h from epaths.in in a
346 # similar way to how Makefile is made from Makefile.in.
347 epaths-force:
348 @for dir in '$(abs_srcdir)' '$(lispdir)' '$(archlibdir)'; do \
349 case $$dir in \
350 *:*) \
351 printf >&2 "Build or installation directory '%s'\\n" "$$dir"; \
352 echo >&2 "cannot contain ':'."; \
353 exit 1;; \
354 esac; \
355 done
356 @(gamedir='${gamedir}'; \
357 sed < ${srcdir}/src/epaths.in > epaths.h.$$$$ \
358 -e 's;\(#.*PATH_LOADSEARCH\).*$$;\1 "${standardlisppath}";' \
359 -e 's;\(#.*PATH_SITELOADSEARCH\).*$$;\1 "${locallisppath}";' \
360 -e 's;\(#.*PATH_DUMPLOADSEARCH\).*$$;\1 "${buildlisppath}";' \
361 -e '/^#define PATH_[^ ]*SEARCH /s/\([":]\):*/\1/g' \
362 -e '/^#define PATH_[^ ]*SEARCH /s/:"/"/' \
363 -e 's;\(#.*PATH_EXEC\).*$$;\1 "${archlibdir}";' \
364 -e 's;\(#.*PATH_INFO\).*$$;\1 "${infodir}";' \
365 -e 's;\(#.*PATH_DATA\).*$$;\1 "${etcdir}";' \
366 -e 's;\(#.*PATH_BITMAPS\).*$$;\1 "${bitmapdir}";' \
367 -e 's;\(#.*PATH_X_DEFAULTS\).*$$;\1 "${x_default_search_path}";' \
368 -e 's;\(#.*PATH_GAME\).*$$;\1 $(PATH_GAME);' \
369 -e 's;\(#.*PATH_DOC\).*$$;\1 "${etcdocdir}";') && \
370 ${srcdir}/build-aux/move-if-change epaths.h.$$$$ src/epaths.h
372 # The w32 build needs a slightly different editing, and it uses
373 # nt/epaths.nt as the template.
375 # Use the value of ${locallisppath} supplied by 'configure',
376 # to support the --enable-locallisppath argument.
378 # In this case, the paths written to 'src/epaths.h' must be in native
379 # MS-Windows format (e.g. 'c:/foo/bar'), because temacs is a MinGW
380 # program that doesn't support MSYS-style paths (e.g. '/c/foo/bar' or
381 # '/foo/bar').
382 epaths-force-w32:
383 @(w32srcdir=`${srcdir}/build-aux/msys-to-w32 "${abs_srcdir}"`; \
384 w32prefix=`${srcdir}/build-aux/msys-to-w32 "${prefix}"`; \
385 w32locallisppath=`${srcdir}/build-aux/msys-to-w32 "${locallisppath}"` ; \
386 w32locallisppath=$${w32locallisppath//$${w32prefix}/"%emacs_dir%"} ; \
387 sed < ${srcdir}/nt/epaths.nt > epaths.h.$$$$ \
388 -e 's;\(#.*PATH_SITELOADSEARCH\).*$$;\1 "'"$${w32locallisppath//;/\\;}"'";' \
389 -e '/^.*#/s/@VER@/${version}/g' \
390 -e '/^.*#/s/@CFG@/${configuration}/g' \
391 -e "/^.*#/s|@SRC@|$${w32srcdir}|g") && \
392 ${srcdir}/build-aux/move-if-change epaths.h.$$$$ src/epaths.h
394 lib-src src: $(NTDIR) lib
396 src: lib-src
398 # We need to build 'emacs' in 'src' to compile the *.elc files in 'lisp'.
399 lisp: src
401 # These targets should be "${SUBDIR} without 'src'".
402 lib lib-src lisp nt: Makefile
403 $(MAKE) -C $@ all
405 # Ideally, VCSWITNESS should be a file that is modified whenever the
406 # repository registers a commit from either a local checkin or a
407 # repository pull. In git there is no single file that guarantees
408 # this, but the local log for the current head should be close enough.
410 # Pass an unexpanded $srcdir to src's Makefile, which then
411 # expands it using its own value of srcdir (which points to the
412 # source directory of src/).
413 dirstate = .git/logs/HEAD
414 VCSWITNESS = $(if $(wildcard $(srcdir)/$(dirstate)),$$(srcdir)/../$(dirstate))
415 src: Makefile
416 $(MAKE) -C $@ VCSWITNESS='$(VCSWITNESS)' all
418 blessmail: Makefile src
419 $(MAKE) -C lib-src maybe-blessmail
421 # We used to have one rule per */Makefile.in, but that leads to race
422 # conditions with parallel makes, so assume that the timestamp on
423 # ./Makefile represents the timestamp on all the other Makefiles.
424 # Similarly, assume the timestamp on ./configure represents the
425 # timestamp on src/config.in.
427 # config.status overrides MAKEFILE_NAME with a bogus name when creating
428 # src/epaths.h, so that 'make epaths-force' does not recursively invoke
429 # config.status and overwrite config.status while executing it (Bug#11214).
431 # 'make bootstrap' overrides MAKEFILE_NAME to a nonexistent file but
432 # then attempts to build that file. This forces 'Makefile', 'lib/Makefile',
433 # etc. to be built without running into similar recursion problems.
434 MAKEFILE_NAME = Makefile
435 $(MAKEFILE_NAME): config.status $(srcdir)/configure \
436 $(srcdir)/lib/gnulib.mk.in \
437 $(srcdir)/Makefile.in $(SUBDIR_MAKEFILES_IN) $(CONFIG_STATUS_FILES_IN)
438 MAKE='$(MAKE)' ./config.status
440 # Don't erase these files if make is interrupted while refreshing them.
441 .PRECIOUS: Makefile config.status
443 config.status: ${srcdir}/configure
444 if [ -x ./config.status ]; then \
445 $(CFG) ./config.status --recheck; \
446 else \
447 $(CFG) $(srcdir)/configure $(CONFIGURE_FLAGS); \
450 $(srcdir)/configure: $(srcdir)/configure.ac $(srcdir)/m4/*.m4
451 cd $(srcdir) && ./autogen.sh autoconf
453 # ==================== Installation ====================
455 .PHONY: install install-arch-dep install-arch-indep install-etcdoc install-info
456 .PHONY: install-man install-etc install-strip install-$(NTDIR)
457 .PHONY: uninstall uninstall-$(NTDIR)
459 ## If we let lib-src do its own installation, that means we
460 ## don't have to duplicate the list of utilities to install in
461 ## this Makefile as well.
463 install: all install-arch-indep install-etcdoc install-arch-dep install-$(NTDIR) blessmail
464 @true
466 ## Ensure that $subdir contains a subdirs.el file.
467 ## Here and elsewhere, we set the umask so that any created files are
468 ## world-readable.
469 ## TODO it might be good to warn about non-standard permissions of
470 ## pre-existing directories, but that does not seem easy.
471 write_subdir=if [ -f "$${subdir}/subdirs.el" ]; \
472 then true; \
473 else \
474 umask 022; \
475 ${MKDIR_P} "$${subdir}"; \
476 (echo "(if (fboundp 'normal-top-level-add-subdirs-to-load-path)"; \
477 echo " (normal-top-level-add-subdirs-to-load-path))") \
478 > "$${subdir}/subdirs.el"; \
481 ### Install the executables that were compiled specifically for this machine.
482 ### We do install-arch-indep first because the executable needs the
483 ### Lisp files and DOC file to work properly.
484 install-arch-dep: src install-arch-indep install-etcdoc install-$(NTDIR)
485 umask 022; ${MKDIR_P} "$(DESTDIR)${bindir}"
486 $(MAKE) -C lib-src install
487 ifeq (${ns_self_contained},no)
488 ${INSTALL_PROGRAM} $(INSTALL_STRIP) src/emacs${EXEEXT} "$(DESTDIR)${bindir}/$(EMACSFULL)"
489 -chmod 755 "$(DESTDIR)${bindir}/$(EMACSFULL)"
490 ifndef NO_BIN_LINK
491 rm -f "$(DESTDIR)${bindir}/$(EMACS)"
492 cd "$(DESTDIR)${bindir}" && $(LN_S_FILEONLY) "$(EMACSFULL)" "$(EMACS)"
493 endif
494 else
495 subdir=${ns_appresdir}/site-lisp && ${write_subdir}
496 rm -rf ${ns_appresdir}/share
497 endif
499 ### Windows-specific install target for installing programs produced
500 ### in nt/, and its Posix do-nothing shadow.
501 install-:
502 install-nt:
503 $(MAKE) -C $(NTDIR) install
505 ## In the share directory, we are deleting:
506 ## applications (with emacs.desktop, also found in etc/)
507 ## emacs (basically empty except for unneeded site-lisp directories)
508 ## icons (duplicates etc/images/icons/hicolor)
510 ## This is install-etc for everything except self-contained-ns builds.
511 ## For them, it is empty.
512 INSTALL_ARCH_INDEP_EXTRA = @INSTALL_ARCH_INDEP_EXTRA@
514 ## https://lists.gnu.org/r/emacs-devel/2007-10/msg01672.html
515 ## Needs to be the user running install, so configure can't set it.
516 set_installuser=for installuser in $${LOGNAME} $${USERNAME} $${USER} \
517 `id -un 2> /dev/null`; do \
518 [ -n "$${installuser}" ] && break ; \
519 done
521 ### Install the files that are machine-independent.
522 ### Most of them come straight from the distribution; the exception is
523 ### the DOC file, which is copied from the build directory.
525 ## We delete each directory in ${COPYDESTS} before we copy into it;
526 ## that way, we can reinstall over directories that have been put in
527 ## place with their files read-only (perhaps because they are checked
528 ## into RCS). In order to make this safe, we make sure that the
529 ## source exists and is distinct from the destination.
531 ## We delete etc/DOC* because there may be irrelevant DOC files from
532 ## other builds in the source directory. This is ok because we just
533 ## deleted the entire installed etc/ directory and recreated it.
534 ## install-etcdoc installs the relevant DOC.
536 ## Note that we install etc/refcards/*.ps if present.
537 ## TODO we should compress these if GZIP_PROG is set.
538 ## It would be simpler to have a separate install rule for etc/refcards
539 ## (maybe move it to doc/refcards?).
541 ## Note that the Makefiles in the etc directory are potentially useful
542 ## in an installed Emacs, so should not be excluded.
544 ## We always create the _default_ locallisppath directories, and
545 ## ensure that they contain a subdirs.el file (via write_subdir).
546 ## This is true even if locallisppath has a non-default value.
547 ## In case of non-default value, we used to create the specified directories,
548 ## but not add subdirs.el to them. This was a strange halfway house.
549 ## Nowadays we do not create non-default directories.
551 ## Note that we use tar instead of plain old cp -R/-r because the latter
552 ## is apparently not portable (even in 2012!).
553 ## https://lists.gnu.org/r/emacs-devel/2012-05/msg00278.html
554 ## I have no idea which platforms Emacs supports where cp -R does not
555 ## work correctly, and therefore no idea when tar can be replaced.
556 ## See also these comments from 2004 about cp -r working fine:
557 ## https://lists.gnu.org/r/autoconf-patches/2004-11/msg00005.html
558 install-arch-indep: lisp install-info install-man ${INSTALL_ARCH_INDEP_EXTRA}
559 -set ${COPYDESTS} ; \
560 unset CDPATH; \
561 $(set_installuser); \
562 for dir in ${COPYDIR} ; do \
563 [ -d $${dir} ] || exit 1 ; \
564 dest="$$1" ; shift ; \
565 if [ -d "$${dest}" ]; then \
566 exp_dest=`cd "$${dest}" && /bin/pwd`; \
567 [ "$$exp_dest" = "`cd $${dir} && /bin/pwd`" ] && continue ; \
568 else true; \
569 fi; \
570 rm -rf "$${dest}" ; \
571 umask 022; ${MKDIR_P} "$${dest}" ; \
572 printf 'Copying %s to %s...\n' "$$dir" "$$dest" ; \
573 (cd $${dir}; tar -chf - . ) \
574 | (cd "$${dest}"; umask 022; \
575 tar -xvf - && cat > /dev/null) || exit 1; \
576 if [ "$${dir}" = "${srcdir}/etc" ]; then \
577 rm -f "$${dest}/DOC"* ; \
578 rm -f "$${dest}/refcards"/*.aux "$${dest}/refcards"/*.dvi; \
579 rm -f "$${dest}/refcards"/*.log "$${dest}/refcards"/*.in; \
580 else true; \
581 fi; \
582 (cd "$${dest}" || exit 1; \
583 for subdir in `find . -type d -print` ; do \
584 chmod a+rx $${subdir} ; \
585 rm -f $${subdir}/.gitignore ; \
586 rm -f $${subdir}/.arch-inventory ; \
587 rm -f $${subdir}/.DS_Store ; \
588 rm -f $${subdir}/#* ; \
589 rm -f $${subdir}/.#* ; \
590 rm -f $${subdir}/*~ ; \
591 rm -f $${subdir}/*.orig ; \
592 rm -f $${subdir}/ChangeLog* ; \
593 [ "$${dir}" != "${srcdir}/etc" ] && \
594 rm -f $${subdir}/[mM]akefile*[.-]in $${subdir}/[mM]akefile ; \
595 done ); \
596 find "$${dest}" -exec chown $${installuser} {} ';' ;\
597 done
598 -rm -f "$(DESTDIR)${lispdir}/subdirs.el"
599 umask 022; $(srcdir)/build-aux/update-subdirs "$(DESTDIR)${lispdir}"
600 subdir="$(DESTDIR)${datadir}/emacs/${version}/site-lisp" ; \
601 ${write_subdir}
602 subdir="$(DESTDIR)${datadir}/emacs/site-lisp" ; \
603 ${write_subdir} || true
604 [ -z "${GZIP_PROG}" ] || { \
605 echo "Compressing *.el etc. ..." && \
606 cd "$(DESTDIR)${lispdir}" && \
607 for f in `find . -name "*.elc" -print | sed 's/.elc$$/.el/'`; do \
608 ${GZIP_PROG} -9n "$$f"; \
609 done; \
610 ${GZIP_PROG} -9n "../etc/publicsuffix.txt"; \
612 -chmod -R a+r "$(DESTDIR)${datadir}/emacs/${version}" ${COPYDESTS}
614 ## The above chmods are needed because "umask 022; tar ..." is not
615 ## guaranteed to do the right thing; eg if we are root and tar is
616 ## preserving source permissions.
618 ## Note that install-arch-indep deletes and recreates the entire
619 ## installed etc/ directory, so we need it to run before this does.
620 install-etcdoc: src install-arch-indep
621 -unset CDPATH; \
622 umask 022; ${MKDIR_P} "$(DESTDIR)${etcdocdir}" ; \
623 exp_etcdocdir=`cd "$(DESTDIR)${etcdocdir}"; /bin/pwd`; \
624 if [ "`cd ./etc; /bin/pwd`" != "$$exp_etcdocdir" ]; \
625 then \
626 docfile="DOC"; \
627 printf 'Copying %s to %s ...\n' "etc/$$docfile" \
628 "$(DESTDIR)${etcdocdir}"; \
629 ${INSTALL_DATA} etc/$${docfile} "$(DESTDIR)${etcdocdir}/$${docfile}"; \
630 $(set_installuser); \
631 chown $${installuser} "$(DESTDIR)${etcdocdir}/$${docfile}" || true ; \
632 else true; fi
634 ## FIXME:
635 ## If info/dir is missing, but we have install-info, we should let
636 ## that handle it. If info/dir is present and we do not have install-info,
637 ## we should check for missing entries and add them by hand.
639 ## FIXME:
640 ## If HAVE_MAKEINFO = no and there are no info files, do not install info/dir.
641 install-info: info
642 umask 022; ${MKDIR_P} "$(DESTDIR)${infodir}"
643 -unset CDPATH; \
644 thisdir=`/bin/pwd`; \
645 exp_infodir=`cd "$(DESTDIR)${infodir}" && /bin/pwd`; \
646 if [ "`cd ${srcdir}/info && /bin/pwd`" = "$$exp_infodir" ]; then \
647 true; \
648 else \
649 [ -f "$(DESTDIR)${infodir}/dir" ] || \
650 [ ! -f ${srcdir}/info/dir ] || \
651 ${INSTALL_DATA} ${srcdir}/info/dir "$(DESTDIR)${infodir}/dir"; \
652 info_misc=`$(MAKE) --no-print-directory -s -C doc/misc echo-info`; \
653 cd ${srcdir}/info ; \
654 for elt in ${INFO_NONMISC} $${info_misc}; do \
655 test "$(HAVE_MAKEINFO)" = "no" && test ! -f $$elt && continue; \
656 for f in `ls $$elt $$elt-[1-9] $$elt-[1-9][0-9] 2>/dev/null`; do \
657 (cd "$${thisdir}"; \
658 ${INSTALL_DATA} ${srcdir}/info/$$f "$(DESTDIR)${infodir}/$$f"); \
659 [ -n "${GZIP_PROG}" ] || continue ; \
660 rm -f "$(DESTDIR)${infodir}/$$f.gz"; \
661 ${GZIP_PROG} -9n "$(DESTDIR)${infodir}/$$f"; \
662 done; \
663 (cd "$${thisdir}"; \
664 ${INSTALL_INFO} --info-dir="$(DESTDIR)${infodir}" "$(DESTDIR)${infodir}/$$elt"); \
665 done; \
668 ## "gzip || true" is because some gzips exit with non-zero status
669 ## if compression would not reduce the file size. Eg, the gzip in
670 ## OpenBSD 4.9 seems to do this (2013/03). In Emacs, this can
671 ## only happen with the tiny ctags.1 manpage. We don't really care if
672 ## ctags.1 is compressed or not. "gzip -f" is another option here,
673 ## but not sure if portable.
674 install-man:
675 umask 022; ${MKDIR_P} "$(DESTDIR)${man1dir}"
676 thisdir=`/bin/pwd`; \
677 cd ${mansrcdir}; \
678 for page in *.1; do \
679 test "$$page" = ChangeLog.1 && continue; \
680 dest=`echo "$${page}" | sed -e 's/\.1$$//' -e '$(TRANSFORM)'`.1; \
681 (cd "$${thisdir}"; \
682 ${INSTALL_DATA} ${mansrcdir}/$${page} "$(DESTDIR)${man1dir}/$${dest}"); \
683 [ -n "${GZIP_PROG}" ] || continue ; \
684 rm -f "$(DESTDIR)${man1dir}/$${dest}.gz"; \
685 ${GZIP_PROG} -9n "$(DESTDIR)${man1dir}/$${dest}" || true; \
686 done
688 ## Install those items from etc/ that need to end up elsewhere.
690 ## If you prefer, choose "emacs22" at installation time.
691 ## Note: emacs22 does not have all the resolutions.
692 EMACS_ICON=emacs
694 install-etc:
695 umask 022; ${MKDIR_P} "$(DESTDIR)${desktopdir}"
696 tmp=etc/emacs.tmpdesktop; rm -f $${tmp}; \
697 sed -e "/^Exec=emacs/ s/emacs/${EMACS_NAME}/" \
698 -e "/^Icon=emacs/ s/emacs/${EMACS_NAME}/" \
699 ${srcdir}/etc/emacs.desktop > $${tmp}; \
700 ${INSTALL_DATA} $${tmp} "$(DESTDIR)${desktopdir}/${EMACS_NAME}.desktop"; \
701 rm -f $${tmp}
702 umask 022; ${MKDIR_P} "$(DESTDIR)${appdatadir}"
703 tmp=etc/emacs.tmpappdata; rm -f $${tmp}; \
704 sed -e "s/emacs\.desktop/${EMACS_NAME}.desktop/" \
705 ${srcdir}/etc/emacs.appdata.xml > $${tmp}; \
706 ${INSTALL_DATA} $${tmp} "$(DESTDIR)${appdatadir}/${EMACS_NAME}.appdata.xml"; \
707 rm -f $${tmp}
708 umask 022; $(MKDIR_P) "$(DESTDIR)$(systemdunitdir)"
709 tmp=etc/emacs.tmpservice; rm -f $${tmp}; \
710 client_name=`echo emacsclient | sed '$(TRANSFORM)'`${EXEEXT}; \
711 sed -e '/^##/d' \
712 -e "/^Documentation/ s/emacs(1)/${EMACS_NAME}(1)/" \
713 -e "/^ExecStart/ s|emacs|${bindir}/${EMACS}|" \
714 -e "/^ExecStop/ s|emacsclient|${bindir}/$${client_name}|" \
715 ${srcdir}/etc/emacs.service > $${tmp}; \
716 $(INSTALL_DATA) $${tmp} "$(DESTDIR)$(systemdunitdir)/${EMACS_NAME}.service"; \
717 rm -f $${tmp}
718 thisdir=`/bin/pwd`; \
719 cd ${iconsrcdir} || exit 1; umask 022 ; \
720 for dir in */*/apps */*/mimetypes; do \
721 [ -d $${dir} ] || continue ; \
722 ( cd "$${thisdir}"; ${MKDIR_P} "$(DESTDIR)${icondir}/$${dir}" ) ; \
723 for icon in $${dir}/${EMACS_ICON}[.-]*; do \
724 [ -r $${icon} ] || continue ; \
725 ext=`echo "$${icon}" | sed -e 's|.*\.||'`; \
726 dest=`echo "$${icon}" | sed -e 's|.*/||' -e "s|\\.$${ext}\$$||" -e 's/$(EMACS_ICON)/emacs/' -e '$(TRANSFORM)'`.$${ext} ; \
727 ( cd "$${thisdir}"; \
728 ${INSTALL_DATA} ${iconsrcdir}/$${icon} "$(DESTDIR)${icondir}/$${dir}/$${dest}" ) \
729 || exit 1; \
730 done ; \
731 done
733 ### Build Emacs and install it, stripping binaries while installing them.
734 install-strip:
735 $(MAKE) INSTALL_STRIP=-s install
737 ### Delete all the installed files that the 'install' target would
738 ### create (but not the noninstalled files such as 'make all' would create).
740 ### Don't delete the lisp and etc directories if they're in the source tree.
741 uninstall: uninstall-$(NTDIR) uninstall-doc
742 $(MAKE) -C lib-src uninstall
743 -unset CDPATH; \
744 for dir in "$(DESTDIR)${lispdir}" "$(DESTDIR)${etcdir}" ; do \
745 if [ -d "$${dir}" ]; then \
746 case `cd "$${dir}" ; /bin/pwd` in \
747 "`cd ${srcdir} ; /bin/pwd`"* ) ;; \
748 * ) rm -rf "$${dir}" ;; \
749 esac ; \
750 case "$${dir}" in \
751 "$(DESTDIR)${datadir}/emacs/${version}"/* ) \
752 rm -rf "$(DESTDIR)${datadir}/emacs/${version}" \
753 ;; \
754 esac ; \
755 fi ; \
756 done
757 -rm -rf "$(DESTDIR)${libexecdir}/emacs/${version}"
758 thisdir=`/bin/pwd`; \
759 (info_misc=`$(MAKE) --no-print-directory -s -C doc/misc echo-info`; \
760 if cd "$(DESTDIR)${infodir}"; then \
761 for elt in ${INFO_NONMISC} $${info_misc}; do \
762 (cd "$${thisdir}"; \
763 $(INSTALL_INFO) --remove --info-dir="$(DESTDIR)${infodir}" "$(DESTDIR)${infodir}/$$elt"); \
764 if [ -n "${GZIP_PROG}" ]; then \
765 ext=.gz; else ext=; fi; \
766 rm -f $$elt$$ext $$elt-[1-9]$$ext $$elt-[1-9][0-9]$$ext; \
767 done; \
769 (if [ -n "${GZIP_PROG}" ]; then \
770 ext=.gz; else ext=; fi; \
771 if cd ${mansrcdir}; then \
772 for page in *.1; do \
773 rm -f "$(DESTDIR)${man1dir}"/`echo "$${page}" | sed -e 's/\.1$$//' -e '$(TRANSFORM)'`.1$$ext; done; \
775 rm -f "$(DESTDIR)${bindir}/$(EMACS)" "$(DESTDIR)${bindir}/$(EMACSFULL)"
776 (if cd "$(DESTDIR)${icondir}"; then \
777 rm -f hicolor/*x*/apps/"${EMACS_NAME}.png" \
778 "hicolor/scalable/apps/${EMACS_NAME}.svg" \
779 hicolor/scalable/mimetypes/`echo emacs-document | sed '$(TRANSFORM)'`.svg; \
781 -rm -f "$(DESTDIR)${desktopdir}/${EMACS_NAME}.desktop"
782 -rm -f "$(DESTDIR)${appdatadir}/${EMACS_NAME}.appdata.xml"
783 -rm -f "$(DESTDIR)$(systemdunitdir)/${EMACS_NAME}.service"
784 ifneq (,$(use_gamedir))
785 for file in snake-scores tetris-scores; do \
786 file="$(DESTDIR)${gamedir}/$${file}"; \
787 [ -s "$${file}" ] || rm -f "$$file"; \
788 done
789 endif
791 ### Windows-specific uninstall target for removing programs produced
792 ### in nt/, and its Posix do-nothing shadow.
793 uninstall-:
794 uninstall-nt:
795 $(MAKE) -C $(NTDIR) uninstall
797 # ==================== Cleaning up and miscellanea ====================
799 .PHONY: mostlyclean clean distclean bootstrap-clean maintainer-clean extraclean
801 ## Eg:
802 ## src_clean:
803 ## make -C src clean
804 define submake_template
805 .PHONY: $(1)_$(2)
806 $(1)_$(2):
807 $$(MAKE) -C $(1) $(2)
808 endef
810 ### 'mostlyclean'
811 ### Like 'clean', but may refrain from deleting a few files that people
812 ### normally don't want to recompile. For example, the 'mostlyclean'
813 ### target for GCC does not delete 'libgcc.a', because recompiling it
814 ### is rarely necessary and takes a lot of time.
815 mostlyclean_dirs = src oldXMenu lwlib lib lib-src nt doc/emacs doc/misc \
816 doc/lispref doc/lispintro
818 $(foreach dir,$(mostlyclean_dirs),$(eval $(call submake_template,$(dir),mostlyclean)))
820 mostlyclean: $(mostlyclean_dirs:=_mostlyclean)
821 [ ! -d test ] || $(MAKE) -C test $@
823 ### 'clean'
824 ### Delete all files from the current directory that are normally
825 ### created by building the program. Don't delete the files that
826 ### record the configuration. Also preserve files that could be made
827 ### by building, but normally aren't because the distribution comes
828 ### with them.
830 ### Delete '.dvi' files here if they are not part of the distribution.
831 clean_dirs = $(mostlyclean_dirs) nextstep
833 $(foreach dir,$(clean_dirs),$(eval $(call submake_template,$(dir),clean)))
835 clean: $(clean_dirs:=_clean)
836 $(MAKE) -C admin/charsets $@
837 [ ! -d test ] || $(MAKE) -C test $@
838 -rm -f *.tmp etc/*.tmp*
839 -rm -rf info-dir.*
841 ### 'bootclean'
842 ### Delete all files that need to be remade for a clean bootstrap.
843 top_bootclean=\
844 rm -f config.cache config.log ${srcdir}/doc/man/emacs.1
846 ### 'distclean'
847 ### Delete all files from the current directory that are created by
848 ### configuring or building the program. If you have unpacked the
849 ### source and built the program without creating any other files,
850 ### 'make distclean' should leave only the files that were in the
851 ### distribution.
852 top_distclean=\
853 ${top_bootclean}; \
854 rm -f config.status config.log~ \
855 Makefile lib/gnulib.mk ${SUBDIR_MAKEFILES}
857 distclean_dirs = $(clean_dirs) leim lisp
859 $(foreach dir,$(distclean_dirs),$(eval $(call submake_template,$(dir),distclean)))
861 maybeclean_dirs = test admin/grammars admin/unidata admin/charsets
863 distclean: $(distclean_dirs:=_distclean)
864 for dir in $(filter-out test,$(maybeclean_dirs)); do \
865 $(MAKE) -C $$dir $@ || exit; \
866 done
867 [ ! -d test ] || $(MAKE) -C test $@
868 ${top_distclean}
870 ### 'bootstrap-clean'
871 ### Delete everything that can be reconstructed by 'make' and that
872 ### needs to be deleted in order to force a bootstrap from a clean state.
873 $(foreach dir,$(distclean_dirs),$(eval $(call submake_template,$(dir),bootstrap-clean)))
875 bootstrap-clean: $(distclean_dirs:=_bootstrap-clean)
876 for dir in $(filter-out test,$(maybeclean_dirs)); do \
877 $(MAKE) -C $$dir $@ || exit; \
878 done
879 [ ! -d test ] || $(MAKE) -C test $@
880 [ ! -f config.log ] || mv -f config.log config.log~
881 rm -rf ${srcdir}/info
882 rm -f ${srcdir}/etc/refcards/emacsver.tex
883 ${top_bootclean}
885 ### 'maintainer-clean'
886 ### Delete everything from the current directory that can be
887 ### reconstructed with this Makefile. This typically includes
888 ### everything deleted by distclean, plus more: C source files
889 ### produced by Bison, tags tables, info files, and so on.
891 ### One exception, however: 'make maintainer-clean' should not delete
892 ### 'configure' even if 'configure' can be remade using a rule in the
893 ### Makefile. More generally, 'make maintainer-clean' should not delete
894 ### anything that needs to exist in order to run 'configure' and then
895 ### begin to build the program.
896 top_maintainer_clean=\
897 ${top_distclean}; \
898 rm -fr autom4te.cache
900 maintainer_clean_dirs = src leim lisp
902 $(foreach dir,$(maintainer_clean_dirs),$(eval $(call submake_template,$(dir),maintainer-clean)))
904 maintainer-clean: bootstrap-clean $(maintainer_clean_dirs:=_maintainer-clean)
905 for dir in $(filter-out test,$(maybeclean_dirs)); do \
906 $(MAKE) -C $$dir $@ || exit; \
907 done
908 [ ! -d test ] || $(MAKE) -C test $@
909 ${top_maintainer_clean}
911 ### This doesn't actually appear in the coding standards, but Karl
912 ### says GCC supports it, and that's where the configuration part of
913 ### the coding standards seem to come from. It's like distclean, but
914 ### it deletes backup and autosave files too.
915 ### Note that we abuse this in some subdirectories (eg leim),
916 ### to delete some generated files that are slow to rebuild.
917 extraclean_dirs = ${NTDIR} lib-src src leim \
918 admin/charsets admin/grammars admin/unidata
920 $(foreach dir,$(extraclean_dirs),$(eval $(call submake_template,$(dir),extraclean)))
922 extraclean: $(extraclean_dirs:=_extraclean)
923 ${top_maintainer_clean}
924 -rm -f config-tmp-*
925 -rm -f *~ \#*
927 # The src subdir knows how to do the right thing
928 # even when the build directory and source dir are different.
929 .PHONY: TAGS tags
930 TAGS tags: lib lib-src src
931 $(MAKE) -C src tags
933 .PHONY: have-tests
934 have-tests:
935 @if test ! -d test; then \
936 echo "You do not seem to have the test/ directory."; \
937 echo "Maybe you are using a release tarfile, rather than a repository checkout."; \
938 exit 1; \
941 check check-maybe check-expensive: have-tests all
942 $(MAKE) -C test $@
944 dist:
945 cd ${srcdir}; ./make-dist
947 DVIS = lispref-dvi lispintro-dvi emacs-dvi misc-dvi
948 HTMLS = lispref-html lispintro-html emacs-html misc-html
949 INFOS = lispref-info lispintro-info emacs-info misc-info
950 PDFS = lispref-pdf lispintro-pdf emacs-pdf misc-pdf
951 PSS = lispref-ps lispintro-ps emacs-ps misc-ps
953 DOCS = $(DVIS) $(HTMLS) $(INFOS) $(PDFS) $(PSS)
954 $(DOCS):
955 $(MAKE) -C doc/$(subst -, ,$@)
957 .PHONY: $(DOCS) docs pdf ps
958 .PHONY: info dvi dist check check-maybe check-expensive html info-real info-dir check-info
960 ## TODO add etc/refcards.
961 docs: $(DOCS)
962 dvi: $(DVIS)
963 html: $(HTMLS)
964 info-real: $(INFOS)
965 pdf: $(PDFS)
966 ps: $(PSS)
968 info-dir: ${srcdir}/info/dir
970 ## Hopefully doc/misc/*.texi is not too long for some systems?
971 srcdir_doc_info_dir_inputs = \
972 ${srcdir}/doc/emacs/emacs.texi \
973 ${srcdir}/doc/lispintro/emacs-lisp-intro.texi \
974 ${srcdir}/doc/lispref/elisp.texi \
975 $(sort $(wildcard ${srcdir}/doc/misc/*.texi))
976 info_dir_inputs = \
977 ../build-aux/dir_top \
978 $(subst ${srcdir}/doc/,,${srcdir_doc_info_dir_inputs})
979 info_dir_deps = \
980 ${srcdir}/build-aux/make-info-dir \
981 ${srcdir}/build-aux/dir_top \
982 ${srcdir_doc_info_dir_inputs}
984 ## It would be much simpler if info/dir was only created in the
985 ## installation location by the install-info rule, but we also
986 ## need one in the source directory for people running uninstalled.
987 ## FIXME it would be faster to use the install-info program if we have it,
988 ## but then we would need to depend on info-real, which would
989 ## slow down parallelization.
990 ${srcdir}/info/dir: ${info_dir_deps}
991 $(AM_V_at)${MKDIR_P} ${srcdir}/info
992 $(AM_V_GEN)(cd ${srcdir}/doc && \
993 AWK='${AWK}' ../build-aux/make-info-dir ${info_dir_inputs} \
994 ) >$@.tmp && mv $@.tmp $@
996 INSTALL_DVI = install-emacs-dvi install-lispref-dvi \
997 install-lispintro-dvi install-misc-dvi
998 INSTALL_HTML = install-emacs-html install-lispref-html \
999 install-lispintro-html install-misc-html
1000 INSTALL_PDF = install-emacs-pdf install-lispref-pdf \
1001 install-lispintro-pdf install-misc-pdf
1002 INSTALL_PS = install-emacs-ps install-lispref-ps \
1003 install-lispintro-ps install-misc-ps
1004 INSTALL_DOC = $(INSTALL_DVI) $(INSTALL_HTML) $(INSTALL_PDF) $(INSTALL_PS)
1006 ## Install non .info forms of the documentation.
1007 ## TODO add etc/refcards.
1008 $(INSTALL_DOC):
1009 $(MAKE) -C doc/$(subst -, install-,$(subst install-,,$@))
1011 .PHONY: $(INSTALL_DOC) install-doc
1012 .PHONY: install-dvi install-html install-pdf install-ps
1014 install-doc: $(INSTALL_DOC)
1015 install-dvi: $(INSTALL_DVI)
1016 install-html: $(INSTALL_HTML)
1017 install-pdf: $(INSTALL_PDF)
1018 install-ps: $(INSTALL_PS)
1021 UNINSTALL_DVI = uninstall-emacs-dvi uninstall-lispref-dvi \
1022 uninstall-lispintro-dvi uninstall-misc-dvi
1023 UNINSTALL_HTML = uninstall-emacs-html uninstall-lispref-html \
1024 uninstall-lispintro-html uninstall-misc-html
1025 UNINSTALL_PDF = uninstall-emacs-pdf uninstall-lispref-pdf \
1026 uninstall-lispintro-pdf uninstall-misc-pdf
1027 UNINSTALL_PS = uninstall-emacs-ps uninstall-lispref-ps \
1028 uninstall-lispintro-ps uninstall-misc-ps
1029 UNINSTALL_DOC = $(UNINSTALL_DVI) $(UNINSTALL_HTML) $(UNINSTALL_PDF) $(UNINSTALL_PS)
1031 $(UNINSTALL_DOC):
1032 $(MAKE) -C doc/$(subst -, uninstall-,$(subst uninstall-,,$@))
1034 .PHONY: $(UNINSTALL_DOC) uninstall-doc
1035 .PHONY: uninstall-dvi uninstall-html uninstall-pdf uninstall-ps
1037 uninstall-doc: $(UNINSTALL_DOC)
1038 uninstall-dvi: $(UNINSTALL_DVI)
1039 uninstall-html: $(UNINSTALL_HTML)
1040 uninstall-pdf: $(UNINSTALL_PDF)
1041 uninstall-ps: $(UNINSTALL_PS)
1044 # Note that man/Makefile knows how to put the info files in $(srcdir),
1045 # so we can do ok running make in the build dir.
1046 # This used to have a clause that exited with an error if MAKEINFO = no.
1047 # But it is inappropriate to do so without checking if makeinfo is
1048 # actually needed - it is not if the info files are up-to-date. (Bug#3982)
1049 # Only the doc/*/Makefiles can decide that, so we let those rules run
1050 # and give a standard error if makeinfo is needed but missing.
1051 # While it would be nice to give a more detailed error message, that
1052 # would require changing every rule in doc/ that builds an info file,
1053 # and it's not worth it. This case is only relevant if you download a
1054 # release, then change the .texi files.
1055 info:
1056 ifneq ($(HAVE_MAKEINFO),no)
1057 $(MAKE) info-real info-dir
1058 endif
1060 ## build-aux/make-info-dir expects only certain dircategories.
1061 check-info: info
1062 cd info ; \
1063 bad= ; \
1064 for file in *; do \
1065 test -f "$${file}" || continue ; \
1066 case $${file} in \
1067 *-[0-9]*|COPYING|dir) continue ;; \
1068 esac ; \
1069 cat=`sed -n 's/^INFO-DIR-SECTION //p' $${file}`; \
1070 case $${cat} in \
1071 "Texinfo documentation system" | "Emacs"| "Emacs lisp" | \
1072 "Emacs editing modes" | "Emacs network features" | \
1073 "Emacs misc features" | "Emacs lisp libraries" ) : ;; \
1074 *) bad="$${bad} $${file}" ;; \
1075 esac; \
1076 done ; \
1077 if test -n "$${bad}"; then \
1078 echo "Unexpected dircategory in: $${bad}" ; \
1079 exit 1 ; \
1080 fi ; \
1081 echo "info files are OK"
1083 #### Bootstrapping.
1085 ### This first cleans the lisp subdirectory, removing all compiled
1086 ### Lisp files. Then re-run make to build all the files anew.
1088 .PHONY: bootstrap
1090 # Bootstrapping does the following:
1091 # * Remove files to start from a bootstrap-clean slate.
1092 # * Run autogen.sh.
1093 # * Rebuild Makefile, to update the build procedure itself.
1094 # * Do the actual build.
1095 bootstrap: bootstrap-clean
1096 cd $(srcdir) && ./autogen.sh autoconf
1097 $(MAKE) MAKEFILE_NAME=force-Makefile force-Makefile
1098 $(MAKE) all
1100 .PHONY: ChangeLog change-history change-history-commit change-history-nocommit
1101 .PHONY: preferred-branch-is-current unchanged-history-files
1103 CHANGELOG = ChangeLog
1104 emacslog = build-aux/gitlog-to-emacslog
1105 # The ChangeLog history files are called ChangeLog.1, ChangeLog.2, ...,
1106 # ChangeLog.$(CHANGELOG_HISTORY_INDEX_MAX). $(CHANGELOG_N) stands for
1107 # the newest (highest-numbered) ChangeLog history file.
1108 CHANGELOG_HISTORY_INDEX_MAX = 3
1109 CHANGELOG_N = ChangeLog.$(CHANGELOG_HISTORY_INDEX_MAX)
1111 # Convert git commit log to ChangeLog file. make-dist uses this.
1112 # I guess this is PHONY so it always updates?
1113 ChangeLog:
1114 $(AM_V_GEN)cd $(srcdir) && \
1115 ./$(emacslog) -o $(CHANGELOG) -n $(CHANGELOG_HISTORY_INDEX_MAX)
1117 # Check that we are in a good state for changing history.
1118 PREFERRED_BRANCH = emacs-26
1119 preferred-branch-is-current:
1120 git branch | grep -q '^\* $(PREFERRED_BRANCH)$$'
1121 unchanged-history-files:
1122 x=$$(git diff-files --name-only $(CHANGELOG_N) $(emacslog)) && \
1123 test -z "$$x"
1125 # Regular expression that matches the newest commit covered by a ChangeLog.
1126 new_commit_regexp = ^commit [0123456789abcdef]* (inclusive)
1128 # Copy newer commit messages to the start of the ChangeLog history file,
1129 # and consider them to be older.
1130 change-history-nocommit: preferred-branch-is-current unchanged-history-files
1131 -rm -f ChangeLog.tmp
1132 $(MAKE) ChangeLog CHANGELOG=ChangeLog.tmp
1133 sed '/^This file records repository revisions/,$$d' \
1134 ChangeLog.tmp >$(CHANGELOG_N).tmp
1135 new_commit_line=`grep '$(new_commit_regexp)' ChangeLog.tmp` && \
1136 sed 's/$(new_commit_regexp).*/'"$$new_commit_line/" \
1137 $(CHANGELOG_N) >>$(CHANGELOG_N).tmp
1138 rm ChangeLog.tmp
1139 mv $(CHANGELOG_N).tmp $(CHANGELOG_N)
1141 change-history: change-history-nocommit
1142 $(MAKE) $@-commit
1144 # If 'make change-history' fails because the newest ChangeLog history
1145 # file contains invalid text, fix the file by hand and then run
1146 # 'make change-history-commit'.
1147 change-history-commit:
1148 git commit -m'; make $@' $(CHANGELOG_N) $(emacslog)
1150 .PHONY: check-declare
1152 check-declare:
1153 @if [ ! -f $(srcdir)/src/emacs ]; then \
1154 echo "You must build Emacs to use this command"; \
1155 exit 1; \
1157 $(MAKE) -C lisp $@